require("src.player")
require("src.wall")
require("src.weapons.pistol")

function love.load()
    world = love.physics.newWorld(0, 0)
    -- mandatory otherision callbacks
    world:setCallbacks(beginContact, endContact, preSolve, postSolve)
    player:load()
    pistol:load()
end

function love.mousepressed(x, y, button, istouch, presses)
    player:mousepressed(button)
end

function love.keypressed(key)
    if key == "escape" then
        love.event.quit(1)
    end
end

function drawColliders()
    for _, body in pairs(world:getBodies()) do
        for _, fixture in pairs(body:getFixtures()) do
            local shape = fixture:getShape()
            if shape:typeOf("CircleShape") then
                local cx, cy = body:getWorldPoints(shape:getPoint())
                love.graphics.circle("line", cx, cy, shape:getRadius())
            elseif shape:typeOf("PolygonShape") then
                love.graphics.polygon("line", body:getWorldPoints(shape:getPoints()))
            else
                love.graphics.line(body:getWorldPoints(shape:getPoints()))
            end
        end
    end 
end

-- mandatory (if empty then dont delete)

function beginContact(a, b, other)
	
end

function endContact(a, b, other)
	
end

function preSolve(a, b, other)
	pistol:preSolve(a, b, other)
end

function postSolve(a, b, other, normalimpulse, tangentimpulse)
	
end

function love.draw()
    --love.graphics.setBackgroundColor(81/255, 142/255, 240/255)
    love.graphics.print(tostring(love.mouse.getPosition()))
    drawColliders()
end

function love.update(dt)
    world:update(dt)
    player:update(dt)
    wall:update(dt)
end