require("src.weapons.pistol")

player = {}

function player:load()
    -- size
    self.shape = love.physics.newRectangleShape(40, 40)
    -- position
    self.body = love.physics.newBody(world, 40, 40)
    self.fixture = love.physics.newFixture(self.body, self.shape)
    self.body:setFixedRotation(true)
    self.body:setType("dynamic")
    self.fixture:setUserData("player")
    -- general or default speed
    self.speed = 200
    self.bullets = {}
    self.direction = math.atan2(love.mouse.getY()-self.body:getY(), love.mouse.getX()-self.body:getX())
end

function player:shoot(dt)
    local px, py = self.body:getPosition()
    local w = math.atan2(love.mouse.getY()-px, love.mouse.getX()-py)
    local bullet = {}
    bullet.body = love.physics.newBody(world, self.body:getX()+math.cos(w), self.body:getY()+math.sin(w))
    bullet.shape = love.physics.newCircleShape(10)
    bullet.fixture = love.physics.newFixture(bullet.body, bullet.shape)
    local e = 200
    
    table.insert(self.bullets, bullet)
end

function player:mousepressed(button)
    if button == 1 and pistol.unlocked then
        self:shoot(love.timer.getDelta())
    end
end

function player:update(dt)
    local rot = math.atan2(love.mouse.getY()-self.body:getY(), love.mouse.getX()-self.body:getX())

    for _,v in ipairs(self.bullets) do
        local e = 200
        local mx, my = love.mouse.getPosition()
        local w = math.atan2(my-self.body:getY(), mx-self.body:getX())
        v.body:setX(v.body:getX()+math.cos(w)*e*dt)
        v.body:setY(v.body:getY()+math.sin(w)*e*dt)
    end

    -- rotate player towards the mouse
    self.body:setAngle(rot)
    local vx = 0
    local vy = 0
    if love.keyboard.isDown("a") then
        vx = self.speed * -1
    end
    if love.keyboard.isDown("d") then
        vx = self.speed * 1
    end
    if love.keyboard.isDown("w") then
        vy = self.speed * -1
    end
    if love.keyboard.isDown("s") then
        vy = self.speed * 1
    end
    self.body:setLinearVelocity(vx, vy)
end